/*
    Ľ: LCDйصĶŵһͷļ--- LCD.H 
    :2011.8.18  
*/

#include	"Include.h"
#include    "LCD.h"
#include	<math.h>


static	LCD_COLOR		LCD_Buffer[LCD_XSIZE*LCD_YSIZE];
static	GDEV	gdev;
static	SURFACE	screen_surface;


#ifdef	ILI9481

#if	LCD_XSIZE==480
#define	LCD_HV_SWAP
#endif


#define		MOSI(a)		gpio->rGPDDAT	= (( gpio->rGPDDAT&(~(1<<1)) ) | ((a&1)<<1))	//GPD1
#define		SCK(a)		gpio->rGPDDAT	= (( gpio->rGPDDAT&(~(1<<9)) ) | ((a&1)<<9))	//GPD9
#define		CS(a)		gpio->rGPDDAT	= (( gpio->rGPDDAT&(~(1<<10)) ) | ((a&1)<<10))	//GPD10


/*============================================================================*/

static void delay(int i)
{
	volatile int a;
	////
	
	while(i--)
	{
		for(a=1000;a>0;a--);
	}
}

static void delay_ms(int i)
{
	volatile int a;
	////
	
	while(i--)
	{
		for(a=10000;a>0;a--);
	}
}

/*============================================================================*/


/*============================================================================*/

/*============================================================================*/

static void spi_send_byte(U8 dat)
{
	volatile	GPIO_REG *gpio	=PA2VA(GPIO_REG_PA_BASE);
	int i;
	////
	
	for(i=0;i<8;i++)
	{
		SCK(0);
		delay(10);

		if(((dat<<i)&0x80)==0x80)
		{
			MOSI(1);
		}
		else
		{
			MOSI(0);
		}
		delay(10);
		SCK(1);
		delay(10);
	}
}

/*============================================================================*/


static	void	write_cmd(U8 cmd)
{
	volatile	GPIO_REG *gpio	=PA2VA(GPIO_REG_PA_BASE);
	
	CS(0);
	delay(10);
	
	SCK(0);
	delay(10);	
	MOSI(0);
	delay(10);
	SCK(1);
	delay(10);
	
	spi_send_byte(cmd);
	delay(10);
	
	CS(1);
	delay_ms(5);
}

/////////////////////////////////////////////////

static	void	write_dat(U8 dat)
{
	volatile	GPIO_REG *gpio	=PA2VA(GPIO_REG_PA_BASE);
	
	CS(0);
	delay(10);
	
	SCK(0);
	delay(10);	
	MOSI(1);
	delay(10);
	SCK(1);
	delay(10);
	
	spi_send_byte(dat);
	delay(10);

	CS(1);
	delay_ms(5);
}


/*============================================================================*/

void ili9481_init(void) 
{  
  	write_cmd(0x11); 
  	delay_ms(150); 
  	write_cmd(0xb4);
  	write_dat(0x10); 
 
   	write_cmd(0xD0);      
  	write_dat(0x07);    
  	write_dat(0x41);    
  	write_dat(0x1d);    

  	write_cmd(0xD1); 
  	write_dat(0x00);    
  	write_dat(0x0a);    
  	write_dat(0x08);    

  	write_cmd(0xD2); 
  	write_dat(0x01);    
  	write_dat(0x11);    

  	    

  	write_cmd(0xC0); 
  	write_dat(0x00); 
  	write_dat(0x3B); 
  	write_dat(0x00); 
  	write_dat(0x02); 
  	write_dat(0x11); 
  
  	write_cmd(0xC1);
  	write_dat(0x10);
  	write_dat(0x13);
  	write_dat(0x88);
  	write_dat(0xc5);
  	write_dat(0x02);
 
 
  	
	
	write_cmd(0xC5);
  	write_dat(0x02);
  	
  	write_cmd(0xC6);       
  	write_dat((1<<4)|(1<<3)|(1<<1)|(1<<0)); 
  	
    
	write_cmd(0xC8);       
	write_dat(0x02);     
	write_dat(0x46);     
	write_dat(0x14);     
	write_dat(0x31);    
	write_dat(0x0a);     
	write_dat(0x04);     
	write_dat(0x37);     
	write_dat(0x24);     
	write_dat(0x57);     
	write_dat(0x13);     
	write_dat(0x06);     
	write_dat(0x0c);



  	write_cmd(0x36); 
 
#if LCD_XSIZE==480 && LCD_YSIZE==320
  	write_dat((0<<7)|(0<<6)|(1<<5)|(1<<3)|(0<<2)|(0<<1)|(0<<0));
#endif

#if	LCD_XSIZE==320 && LCD_YSIZE==480
  	write_dat((0<<7)|(1<<6)|(0<<5)|(1<<3)|(0<<2)|(0<<1)|(0<<0));
#endif
 // write_dat(0x002b); 
   
  	write_cmd(0x3A); 
  	write_dat(0x66); //262K
   	
  
  	write_cmd(0x2A); 
  	write_dat(0x00); 
  	write_dat(0x00); 
  	write_dat(LCD_XSIZE>>8); 
  	write_dat(LCD_XSIZE); 

  	write_cmd(0x2B); 
  	write_dat(0x00); 
  	write_dat(0x00); 
  	write_dat(LCD_YSIZE>>8); 
  	write_dat(LCD_YSIZE); 

  	delay_ms(50); 
  	write_cmd(0x29); 
  	write_cmd(0x2C); 
  
} 

static	void	tc350_init(void)
{
	volatile	GPIO_REG *gpio	=PA2VA(GPIO_REG_PA_BASE);
	
	gpio->rGPDCON	&=~((3<<20)|(3<<18)|(3<<2));
	gpio->rGPDCON	|=((1<<20)|(1<<18)|(1<<2));	//GPD10,GPD9,GPD1, output.
	gpio->rGPDUP	&=~((1<<10)|(1<<9)|(1<<1));
	////////
		
	
	Sleep(50);
		
	gpio->rGPGCON	&=~(3<<8);		//GPG4 -> LCD_nRST,output.
	gpio->rGPGCON |=(1<<4);	
	gpio->rGPGUP	&=~(1<<4);
	////
	gpio->rGPGDAT |=(1<<4);
	Sleep(100);
	gpio->rGPGDAT &=~(1<<4);
	Sleep(100);
	gpio->rGPGDAT |=(1<<4);
	Sleep(100);
	////
	
	SCK(0);
	MOSI(1);

	delay_ms(10);
	
	ili9481_init();
 	DebugPrintf("ILI9481 Init\r\n");
}

#endif      //  #ifdef	ILI9481
/*============================================================================*/

static	int	lcd_init(void)      // LCD ʼ
{
	volatile	LCD_REG		*lcd	=PA2VA(LCD_REG_PA_BASE);
	volatile	GPIO_REG	*gpio	=PA2VA(GPIO_REG_PA_BASE);
	volatile	CLKPWR_REG	*clk	=PA2VA(CLKPWR_REG_PA_BASE);
	U16 lcd_horizon_value,lcd_line_value;
	

#ifdef	ILI9481
	tc350_init();
#endif	

#ifdef	LCD_HV_SWAP
	lcd_horizon_value 	= LCD_YSIZE-1;
	lcd_line_value 		= LCD_XSIZE-1;
#else
	lcd_horizon_value 	= LCD_XSIZE-1;
	lcd_line_value 		= LCD_YSIZE-1;
#endif
	
	//////////////////////
	clk->rCLKCON	|=(1<<5);
	

	gpio->rGPCUP	=0x00000000; 	//Enable Pull-up register
    gpio->rGPCCON	=0xaaaaaaaa; 	//Initialize VD[7:0],LCDVF[2:0],VM,VFRAME,VLINE,VCLK,LEND 

    gpio->rGPDUP	=0x00000000;	//Enable Pull-up register
    gpio->rGPDCON	=0xaaaaaaaa;	//Initialize VD[15:8]
 
	
#if	LCD_BPP==16	
	lcd->rLCDCON1=(CLKVAL_TFT<<8)|(MVAL_USED<<7)|(3<<5)|(12<<1)|0;
#endif

#if	LCD_BPP==24
	lcd->rLCDCON1=(CLKVAL_TFT<<8)|(MVAL_USED<<7)|(3<<5)|(13<<1)|0;
#endif

    	// TFT LCD panel,16bpp TFT,ENVID=off
	lcd->rLCDCON2 	= (VBPD<<24) | (lcd_line_value<<14) | (VFPD<<6) | (VSPW);
	lcd->rLCDCON3 	= (HBPD<<19) | (lcd_horizon_value<<8) | (HFPD);
	lcd->rLCDCON4 	= (13<<8) | (HSPW);
	lcd->rLCDCON5 	= (1<<11) | (INVVCLK<<10) | (INVVLINE<<9) | (INVVFRAME<<8) | (INVVD<<7) | (INVVDEN<<6) | (1<<3)  |(BSWP<<1)|(HWSWP<<0) ;
	lcd->rLCDSADDR1	= (((U32)LCD_BUF_PA_BASE >> 22) << 21) | ((M5D((U32)LCD_BUF_PA_BASE >> 1)) << 0);
				
	lcd->rLCDSADDR2	= M5D( ((U32)LCD_BUF_PA_BASE+LCD_BUF_SIZE)>>1 ); 
	lcd->rLCDSADDR3	= (((LCD_XSIZE-LCD_XSIZE)/1)<<11)|(LCD_XSIZE/1); 

	//	rLPCSEL&=(~7); // Disable LPC3600
	lcd->rTPAL=0; // Disable Temp Palette
	lcd->rLCDCON1|=(1<<0); 	// ENVID=ON	
	DebugPrintf("LCDInit End(%dx%d,%dbpp)\n",LCD_XSIZE,LCD_YSIZE,LCD_BPP);


}

/*============================================================================*/

static	int	lcd_resume(void)
{

}

/*============================================================================*/

static	int	lcd_suspend(void)
{


}

/*============================================================================*/
/*============================================================================*/
/*============================================================================*/

void	get_screen_surface(struct SURFACE* Surface)
{
	Surface->buf		=screen_surface.buf;
	Surface->bpp		=screen_surface.bpp;
	Surface->xref		=screen_surface.xref;
	Surface->yref		=screen_surface.yref;
	Surface->xmax		=screen_surface.xmax;
	Surface->ymax		=screen_surface.ymax;
	Surface->xoffset	=screen_surface.xoffset;
	Surface->yoffset	=screen_surface.yoffset;
	Surface->offset		=screen_surface.offset;
	Surface->cur		=screen_surface.cur;

}


/*============================================================================*/
/*============================================================================*/
/*============================================================================*/

static	COLORREF	color_ref(U8 r,U8 g,U8 b)
{
	
	return	LCD_COLORREF(r,g,b);
}

/*============================================================================*/

static	void	get_rgb(U8 *r,U8 *g,U8 *b,COLORREF color)
{

	*r	=GET_R(color);
	*g	=GET_G(color);
	*b	=GET_B(color);	

}

/*============================================================================*/


__inline	static	COLORREF	gdev_alpha_blend_color(COLORREF fr_c,COLORREF bk_c,U8 alpha)
{
	return	LCD_COLORREF(	( GET_R(fr_c) * alpha + GET_R(bk_c) * (255-alpha))>>8,
							( GET_G(fr_c) * alpha + GET_G(bk_c) * (255-alpha))>>8,	
							( GET_B(fr_c) * alpha + GET_B(bk_c) * (255-alpha))>>8);	

}
   

/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


static	void	set_pixel(struct SURFACE *Surface,int x,int y,COLORREF c)
{

	__set_pixel(Surface,x,y,c);
}

////

/*============================================================================*/

static	COLORREF	get_pixel(struct SURFACE *Surface,int x,int y)
{
	
	return	__get_pixel(Surface,x,y);
}


/*============================================================================*/

static	void	hline(struct SURFACE *Surface,int x0,int y0,int x1,COLORREF c)
{
	LCD_COLOR *p;
	////
	
	if(x0<x1)
	{
		p	=__set_addr(Surface,x0,y0);
		while(x0++<=x1)
		{
			__set_data(p,c);
		}
	}
	else
	{
		p	=__set_addr(Surface,x1,y0);
		while(x1++<=x0)
		{
			__set_data(p,c);
		}
	}
}

/*============================================================================*/

static	void	vline(struct SURFACE *Surface,int x0,int y0,int y1,COLORREF c)
{

	int	y_inc;
	LCD_COLOR *p;
	////
	
	if(y0<y1)
	{
		p		=__set_addr(Surface,x0,y0);
		y_inc	=Surface->xref;
		
		for(;y0<y1;y0++,p+=y_inc)
		{
			*p=c;
		}
	}
	else
	{
		p		=__set_addr(Surface,x0,y1);
		y_inc	=Surface->xref;
		
		for(;y1<y0;y1++,p+=y_inc)
		{
			*p=c;
		}
	}
	
}

/*============================================================================*/

static	void	line(struct SURFACE *Surface,int startx,int starty,int endx,int endy,COLORREF c)
{

   int t, distance;
   int xerr = 0, yerr = 0, delta_x, delta_y;
   int incx, incy;

   
   // compute the distances in both directions  
   delta_x = endx - startx;
   delta_y = endy - starty;
   
   // compute the direction of increment, an increment of 0 means either a vertical or horizontal line.
   if(delta_x > 0)
   {
   		incx = 1;
   }
   else if(delta_x == 0)
   {
  	 	incx = 0;
   }
   else
   { 
   		incx = -1; 
   		delta_x = -delta_x;
   }
   ////
   
   if(delta_y > 0)
   {
  	 	incy = 1;
   }
   else if(delta_y == 0)
   {
    	incy = 0;
   }
   else
   { 
   		incy = -1;
  		delta_y = -delta_y;
   }
   
   // determine which distance is greater 
   if(delta_x  > delta_y)
   {
   		distance = delta_x;
   }
   else
   {
    	distance = delta_y;
   }
   
   // draw the line 
   for(t = 0; t < distance + 1; t++)
   {
      xerr += delta_x;
      yerr += delta_y;
      
      if(xerr > distance)
      {
         xerr -= distance;
         startx += incx;
      }
      
      if(yerr > distance)
      {
         yerr -= distance;
         starty += incy;
      }
      
	  __set_pixel(Surface,startx,starty,c);
     
   }

}

/*============================================================================*/

static	void	fill_rectangle(struct SURFACE *Surface,int x,int y,int dx,int dy,COLORREF c)
{

	LCD_COLOR *p,*p0;
	int size;
	////
		
	p=__set_addr(Surface,x,y);
	
	size	=sizeof(LCD_COLOR)*dx;
	p0		=MemAlloc(size);
	
	for(x=0;x<dx;x++)
	{
		p0[x]=c;
	}
	
	for(y=0;y<dy;y++)
	{
		memcpy(p,p0,size);
		p+=Surface->xref;
	}
	
	MemFree(p0);
}


/*============================================================================*/

static	void	put_image(struct SURFACE *Surface,int x,int y,int dx,int dy,COLORREF *buf,int width,int height,int argb)
{
	int		xx,i;
	LCD_COLOR *dst_p,dst_c;
	COLORREF *src_p,src_c;
	////	

	dx	=x+dx;
	dy	=y+dy;
	
	i	=0;
	
	if(argb)
	{
		for(y = y;y < dy;y++,i++)
		{
				
			src_p	=buf+i*width;
			dst_p	=__set_addr(Surface,x,y);
			
			for(xx = x;xx < dx;xx++)
			{
				src_c	=*src_p++;
				
				switch(src_c>>24)
				{
					case	0:
							dst_p++;
							break;
							////
					case	255:
							*dst_p++=src_c;
							break;
							////
					default:
							dst_c		=*dst_p;
							*dst_p++	=gdev_alpha_blend_color(src_c,dst_c,src_c>>24);
							break;
				}
				
			}
			
		}

	}
	else
	{
		for(y = y;y < dy;y++,i++)
		{
				
			src_p	=buf+i*width;
			dst_p	=__set_addr(Surface,x,y);
			
			for(xx = x;xx < dx;xx++)
			{
				*dst_p++	=*src_p++;	
			}
			
		}
	}

}

/*============================================================================*/

static	void	get_image(struct SURFACE *Surface,int x,int y,int dx,int dy,COLORREF *buf,int width,int height,int argb)
{

	int	xx,yy,i;
	LCD_COLOR *dst_p;
	COLORREF *src_p;
		
	////
	
	dx	=x+dx;
	dy	=y+dy;

	i=0;
	for(yy = y;yy < dy;yy++,i++)
	{
			
		src_p	=buf+i*width;
		dst_p	=__set_addr(Surface,x,yy);
		
		for(xx = x;xx < dx;xx++)
		{
			*src_p++=__get_data(dst_p);	
		}
		
	}

}

/*============================================================================*/

void	draw_dib_1bpp(SURFACE *Surface,int x,int y,int width,U8 *p,COLORREF *pal)
{
	LCD_COLOR *dst_p;
	int	i;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	=x+width-1;
	

	while(1)
	{
		i=*p++;
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>7)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>6)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>5)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>4)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>3)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>2)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>1)&0x01]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>0)&0x01]);	
		
		
	}


}

/*============================================================================*/

void	draw_dib_4bpp(SURFACE *Surface,int x,int y,int width,U8 *p,COLORREF *pal)
{
	LCD_COLOR *dst_p;
	int	i;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	=x+width-1;
	

	while(1)
	{
		i=*p++;
		
		if(x++>width)	break;
		__set_data(dst_p,pal[(i>>4)&0x0f]);	
		
		if(x++>width)	break;
		__set_data(dst_p,pal[i&0x0f]);	
	}


}

/*============================================================================*/

void	draw_dib_8bpp(SURFACE *Surface,int x,int y,int width,U8 *p,COLORREF *pal)
{
	LCD_COLOR *dst_p;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	+=x;
	

	while(x++<width)
	{
		__set_data(dst_p,pal[*p++]);											
	}

}

/*============================================================================*/

void	draw_dib_RGB555(SURFACE *Surface,int x,int y,int width,U8 *p)
{
	
	LCD_COLOR *dst_p;
	U16 color;
	//U8 r,g,b;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	+=x;
	
	while(x++<width)
	{
/*	
		color=*p++;
		color|=*p++<<8;
		
		r	=(color>>10)&0x1f;
		g	=(color>>5)&0x1f;
		b	=(color&0x1f);
		__set_data(dst_p,LCD_COLORREF(r<<3,g<<3,b<<3));
*/
	
		color	=*(U16*)p;
		p+=2;
		__set_data(dst_p,	LCD_COLORREF(	((color>>10)&0x1F)<<3,
											((color>>5)&0x1F)<<3,
											((color>>0)&0x1F)<<3
										)
					);
							
	}

}

/*============================================================================*/
void	draw_dib_RGB888(SURFACE *Surface,int x,int y,int width,U8 *p)
{
	
	LCD_COLOR *dst_p;
	U8 r,g,b;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	+=x;
	
						
	while(x++<width)
	{
		b=*p++;
		g=*p++;
		r=*p++;
		
		__set_data(dst_p,LCD_COLORREF(r,g,b));
		
							
	}

}
void	draw_dib_BGR888(SURFACE *Surface,int x,int y,int width,U8 *p)
{
	
	LCD_COLOR *dst_p;
	////
	
	
	dst_p	=__set_addr(Surface,x,y);		
	width	+=x;
	
						
	while(x++<width)
	{		
		__set_data(dst_p,LCD_COLORREF(*p++,*p++,*p++));		
							
	}

}

/*============================================================================*/
void		draw_dib_ARGB8888(SURFACE *Surface,int x,int y,int width,U8 *p)
{
	
	LCD_COLOR *dst_p;
	U8 a,r,g,b;
	////
		
	dst_p	=__set_addr(Surface,x,y);		
	width	+=x;
	while(x++<width)
	{
		b=*p++;
		g=*p++;
		r=*p++;
		a=*p++;
						
		switch(a)
		{
							
						
			case	0:
					__next_addr(dst_p);
					break;
									
			case	255:
					__set_data(dst_p,LCD_COLORREF(r,g,b));
					break;
					////
							
			default:
					__set_data(dst_p,gdev_alpha_blend_color(LCD_COLORREF(r,g,b),*dst_p,a));
					break;
					////
		}
											
	}
		
}


/*============================================================================*/

/*============================================================================*/

/*============================================================================*/

__inline	static	int	__rand_val(void)
{
	
	static	UINT val;
	////
	
	val	=(val*(val&0x5AA5)-537)-(1836+(val>>7));	
	return (val*643)>>5;
	
}

////

static	void	dithered_fill(struct SURFACE *Surface,int x,int y,int dx,int dy,COLORREF c,U8 v)
{
	LCD_COLOR *p;
	int i,r,g,b;
	////
	
	r	=GET_R(c);
	g	=GET_G(c);
	b	=GET_B(c);
	
	if((r+v)>255)	r=255-r;
	if((g+v)>255)	g=255-g;
	if((b+v)>255)	b=255-b;
	
	p=__set_addr(Surface,x,y);
	
	for(y=0;y<dy;y++)
	{
		for(x=0;x<dx;x++)
		{
			i	=__rand_val()%v;
			*(p+x)=RGB(r+i,g+i,b+i);
		}
		
		p+=Surface->xref;
	}

}

/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/

static	int	gdev_bit_blt_srccopy(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = source
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	

	xx0	=sizeof(LCD_COLOR)*(dst_dx-dst_x);
	
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		
		/*		
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p++	=*src_p++;
						
		}
		*/
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);

		memcpy(dst_p,src_p,xx0);
		
						
	}

}

////////

static	int	gdev_bit_blt_srcpaint(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = source OR dest
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p++	|=*src_p++;
		}
						
	}

}

////////

static	int	gdev_bit_blt_srcand(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = source AND dest
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p++	&=*src_p++;
		}
						
	}

}

////////

static	int	gdev_bit_blt_srcinvert(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = source XOR dest
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p++	^=*src_p++;
		}
						
	}

}

////////

static	int	gdev_bit_blt_srcerase(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = source AND (NOT dest )
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=~((*dst_p++)&(*src_p++));
		}
						
	}

}

////////

static	int	gdev_bit_blt_notsrccopy(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = (NOT source)
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p++	=~(*src_p++);
		}
						
	}

}

////////

static	int	gdev_bit_blt_notsrcerase(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y)
{
	//// dest = (NOT src) AND (NOT dest)
	
	int	xx0;
	LCD_COLOR *src_p,*dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++,src_y++)
	{
							
		src_p	=__set_addr(srcSurface,src_x,src_y);
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=(~(*src_p++))&(~(*dst_p++));
		}
						
	}

}

////////

static	int	gdev_bit_blt_dstinvert(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)
{
	//// dest = (NOT dest)
	
	int	xx0;
	LCD_COLOR *dst_p;
	////

	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	for(;dst_y<dst_dy;dst_y++)
	{
							
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=~*dst_p++;
		}
						
	}

}

////////

static	int	gdev_bit_blt_blackness(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)
{
	//// dest = BLACK 
	
	int	xx0;
	LCD_COLOR *dst_p;
	////
	
	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	
	for(;dst_y<dst_dy;dst_y++)
	{
							
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=LCD_COLORREF(0,0,0);
		}
						
	}

}

////////

static	int	gdev_bit_blt_whiteness(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)
{
	//// dest = WHITE
	
	int	xx0;
	LCD_COLOR *dst_p;
	////
	
	dst_dx		=dst_x+dst_dx;
	dst_dy		=dst_y+dst_dy;
	
	for(;dst_y<dst_dy;dst_y++)
	{
							
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=LCD_COLORREF(255,255,255);
		}
						
	}

}

////////


/*============================================================================*/

static	int	gdev_bit_blt(	
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,
U32 rop)

{
	switch(rop)
	{
		case	SRCCOPY:	
		default:
				// dest = source
				return	gdev_bit_blt_srccopy(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
												srcSurface,src_x,src_y);
				////////
				
		case	SRCPAINT:
				// dest = source OR dest
				return	gdev_bit_blt_srcpaint(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
												srcSurface,src_x,src_y);
				////////
				
		case	SRCAND:
				// dest = source AND dest
				return	gdev_bit_blt_srcand(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
												srcSurface,src_x,src_y);
				////////

		case	SRCINVERT:
				// dest = source XOR dest
				return	gdev_bit_blt_srcinvert(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
												srcSurface,src_x,src_y);
				////////

		case	SRCERASE:
				// dest = source AND (NOT dest )
				return	gdev_bit_blt_srcerase(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
												srcSurface,src_x,src_y);
				////////

		case	NOTSRCCOPY:
				// dest = (NOT source)
				return	gdev_bit_blt_notsrccopy(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y);
				////////

		case	NOTSRCERASE:
				// dest = (NOT src) AND (NOT dest)
				return	gdev_bit_blt_notsrcerase(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y);
				////////

		case	DSTINVERT:
				// dest = (NOT dest)
				return	gdev_bit_blt_dstinvert(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);								
				////////

		case	BLACKNESS:
				// dest = BLACK
				return	gdev_bit_blt_blackness(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);								
				////////

		case	WHITENESS:
				// dest = WHITE
				return	gdev_bit_blt_whiteness(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);								
				////////
				
	}
	
	
}

/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


static	int	gdev_stretch_blt_srccopy(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{	
	//// dest = source

	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
							
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p++	=__get_pixel(srcSurface,xx1>>16,src_y>>16);						
		}
								
	}


}

////////

static	int	gdev_stretch_blt_srcpaint(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = source OR dest
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p++	|=__get_pixel(srcSurface,xx1>>16,src_y>>16);						
		}
								
								
	}


}

////////

static	int	gdev_stretch_blt_srcand(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = source AND dest	
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p++	&=__get_pixel(srcSurface,xx1>>16,src_y>>16);						
		}
								
								
	}


}

////////

static	int	gdev_stretch_blt_srcinvert(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = source XOR dest
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p++	^=__get_pixel(srcSurface,xx1>>16,src_y>>16);						
		}
								
								
	}

}

////////

static	int	gdev_stretch_blt_srcerase(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = source AND (NOT dest )
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p	=~((*dst_p++) & __get_pixel(srcSurface,xx1>>16,src_y>>16));						
		}
								
								
	}

}

////////

static	int	gdev_stretch_blt_notsrccopy(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = (NOT source)
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p++	=~__get_pixel(srcSurface,xx1>>16,src_y>>16);						
		}
								
								
	}

}

////////

static	int	gdev_stretch_blt_notsrcerase(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy)

{
	//// dest = (NOT src) AND (NOT dest)
	
	int 	xx0,xx1,x_scal,y_scal;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	src_x	<<=16;
	src_y	<<=16;
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
	{
							
		xx0		=dst_x;
		xx1		=src_x;
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
								
		for(;xx0<dst_dx;xx0++,xx1+=x_scal)
		{		
			*dst_p	=(~( __get_pixel(srcSurface,xx1>>16,src_y>>16))) & (~(*dst_p++));						
		}
								
								
	}

}

////////

static	int	gdev_stretch_blt_dstinvert(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)

{
	//// dest = (NOT dest)
	
	int 	xx0;
	LCD_COLOR *dst_p;
	////
	//x,yϵ(㷨Ż:->˷->ӷ)
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(;dst_y<dst_dy;dst_y++)
	{
							
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
			*dst_p	=~*dst_p++;
		}
						
	}

}

////////

static	int	gdev_stretch_blt_blackness(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)

{
	//// dest = BLACK 
	
	int 	xx0;
	LCD_COLOR *dst_p;
	////
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(xx0=dst_x;xx0<dst_dx;xx0++)
	{
								
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
						
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
				*dst_p++	=LCD_COLORREF(0,0,0);
		}
							
	}
	

}

////////

static	int	gdev_stretch_blt_whiteness(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy)

{
	//// dest = WHITE
	
	int 	xx0;
	LCD_COLOR *dst_p;
	////
	
	dst_dx	+=dst_x;	//dst_xΪ
	dst_dy	+=dst_y;	//dst_yΪ
	
	for(xx0=dst_x;xx0<dst_dx;xx0++)
	{
								
		dst_p	=__set_addr(dstSurface,dst_x,dst_y);
						
		for(xx0=dst_x;xx0<dst_dx;xx0++)
		{
				*dst_p++	=LCD_COLORREF(255,255,255);
		}
							
	}
	

}


/*============================================================================*/

static	int	gdev_stretch_blt(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy,
U32 rop)
{
	switch(rop)
	{
		case	SRCCOPY:			
		default:
				// dest = source
				return	gdev_stretch_blt_srccopy(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y,src_dx,src_dy);
		case	SRCPAINT:		
				// dest = source OR dest	
				return	gdev_stretch_blt_srcpaint(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y,src_dx,src_dy);
		case	SRCAND:			
				// dest = source AND dest	
				return	gdev_stretch_blt_srcand(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y,src_dx,src_dy);
		case	SRCINVERT:		
				// dest = source XOR dest	
				return	gdev_stretch_blt_srcinvert(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y,src_dx,src_dy);
		case	SRCERASE:		
				// dest = source AND (NOT dest )
				return	gdev_stretch_blt_srcerase(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
													srcSurface,src_x,src_y,src_dx,src_dy);
		case	NOTSRCCOPY:		
				// dest = (NOT source)
				return	gdev_stretch_blt_notsrccopy(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
														srcSurface,src_x,src_y,src_dx,src_dy);
		case	NOTSRCERASE:	
				// dest = (NOT src) AND (NOT dest)	
				return	gdev_stretch_blt_notsrcerase(	dstSurface,dst_x,dst_y,dst_dx,dst_dy,
														srcSurface,src_x,src_y,src_dx,src_dy);
		case	DSTINVERT:		
				// dest = (NOT dest)	
				return	gdev_stretch_blt_dstinvert(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);
												
		case	BLACKNESS:		
				// dest = BLACK 	
				return	gdev_stretch_blt_blackness(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);
													
		case	WHITENESS:		
				// dest = WHITE 	
				return	gdev_stretch_blt_whiteness(	dstSurface,dst_x,dst_y,dst_dx,dst_dy);
																
	}
	
}

/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/


static	int	gdev_transparent_blt(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy,
struct _TRANSBLT_OP *trans_op)
{
	int 	xx0,xx1,x_scal,y_scal;
	COLORREF color;
	LCD_COLOR *dst_p,*src_p,trans_color;
	////

	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	
	dst_dx	+=dst_x;	//dst_xĽ
	dst_dy	+=dst_y;	//dst_yĽ
	
	trans_color	=trans_op->Color;
	
	switch(trans_op->Mode)
	{
		
		case	BLT_COLOR_EXCEPT:	//ֻƲtrans->Colorɫ
				
				if((dst_dx==src_dx) && (dst_dy==src_dy))
				{
					for(;dst_y<dst_dy;dst_y++,src_y++)
					{
											
						src_p	=__set_addr(srcSurface,src_x,src_y);
						dst_p	=__set_addr(dstSurface,dst_x,dst_y);
									
						for(xx0=dst_x;xx0<dst_dx;xx0++)
						{
							color	=*src_p++;
							
							if(color!=trans_color)
							{
								*dst_p++	=color;
							}
							else
							{
								dst_p++;
							}
										
						}
										
					}

				}
				else
				{	
					src_x	<<=16;
					src_y	<<=16;

					for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
					{
						
						xx0		=dst_x;
						xx1		=src_x;
						dst_p	=__set_addr(dstSurface,dst_x,dst_y);
							
						for(;xx0<dst_dx;xx0++,xx1+=x_scal)
						{
							color=__get_pixel(srcSurface,xx1>>16,src_y>>16);
							if(color!=trans_color)
							{
								__set_data(dst_p,color);
							}
							else
							{
								dst_p++;
							}
													
								
						}
							
							
					}
				}
				return 1;
				////////
		
		case	BLT_COLOR_ONLY:		//ֻƵtrans->Colorɫ
		
				if((dst_dx==src_dx) && (dst_dy==src_dy))
				{
					for(;dst_y<dst_dy;dst_y++,src_y++)
					{
											
						src_p	=__set_addr(srcSurface,src_x,src_y);
						dst_p	=__set_addr(dstSurface,dst_x,dst_y);
									
						for(xx0=dst_x;xx0<dst_dx;xx0++)
						{
							color	=*src_p++;
							if(color==trans_color)
							{
								*dst_p++	=color;
							}
							else
							{
								dst_p++;
							}
										
						}
										
					}

				}
				else
				{	
					src_x	<<=16;
					src_y	<<=16;

					for(;dst_y<dst_dy;dst_y++,src_y+=y_scal)
					{
						
						xx0		=dst_x;
						xx1		=src_x;
						dst_p	=__set_addr(dstSurface,dst_x,dst_y);
							
						for(;xx0<dst_dx;xx0++,xx1+=x_scal)
						{
							color=__get_pixel(srcSurface,xx1>>16,src_y>>16);
							if(color==trans_color)
							{
								__set_data(dst_p,color);
							}
							else
							{
								dst_p++;
							}
													
								
						}
							
							
					}
				}
				return 1;
				////////
				
		default:	return 0;		
				
	
	
	}

}

/*============================================================================*/

static	int	gdev_rotate_blt(
struct SURFACE *dstSurface,int dst_cx,int dst_cy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy,
int angle)
{
	//float radians; 
	S32 cos_a,sin_a; 
	S32 minx,miny;
	S32	inc_x,inc_y;
	S32 xx,yy,xx0,yy0,xx1,yy1; 
	S32 dst_x,dst_y,dst_dx,dst_dy;
	///////////

	//angle		%=360;
	//radians	=(2*3.1416*angle)/360;
	
	cos_a	=(float)cos((2*3.1416*angle)/360)*65536.0;
	sin_a	=(float)sin((2*3.1416*angle)/360)*65536.0;
	
	xx	=(-src_dy*sin_a)>>16;
	yy	=(src_dy*cos_a)>>16;
	xx0	=(src_dx*cos_a-src_dy*sin_a)>>16;
	yy0	=(src_dy*cos_a+src_dx*sin_a)>>16;
	xx1	=(src_dx*cos_a)>>16;
	yy1	=(src_dx*sin_a)>>16;
	
	minx	=MIN((float)0,MIN(xx,MIN(xx0,xx1)));
	miny	=MIN((float)0,MIN(yy,MIN(yy0,yy1)));
	
	xx	=MAX(xx,MAX(xx0,xx1));  //maxx
	yy	=MAX(yy,MAX(yy0,yy1));	//maxy


	
	dst_dx	=(angle>90&&angle<180)?(-minx):(xx-minx);	//Ӿο
	dst_dy	=(angle>180&&angle<270)?(-miny):(yy-miny);	//Ӿθ߶

	dst_x	=dst_cx-(dst_dx>>1);
	dst_y	=dst_cy-(dst_dy>>1);
	////
	
	src_dx	=src_x+src_dx-1;	//src_dxΪ
	src_dy	=src_y+src_dy-1;	//src_dyΪ
	////

	if((dst_y+dst_dy)>dstSurface->ymax)
	{
		dst_dy	=dstSurface->ymax-dst_y;
	}
	
	
	if((dst_x+dst_dx)>dstSurface->xmax)
	{
		dst_dx	=dstSurface->xmax-dst_x;
	}

	////
	if(dst_y<0)
	{
		yy	=0-dst_y;
		yy0	=0;
	}
	else
	{
		yy	=0;
		yy0	=dst_y;			
	}

	////
	for(;yy<dst_dy;yy++,yy0++)
	{ 
		//float f1,f2,f3;
		
		inc_x	=src_x + (((yy+miny)*sin_a)>>16) + ((minx*cos_a)>>16);
		inc_y	=src_y + (((yy+miny)*cos_a)>>16) - ((minx*sin_a)>>16);
		
		////
		if(dst_x<0)
		{
			xx	=0-dst_x;
			xx0	=0;
		}
		else
		{
			xx	=0;
			xx0	=dst_x;	
		}
		////
		/*
		f1	=34.7;
		f2	=12.324;
		*/
		
		for(;xx<dst_dx;xx++,xx0++) 
		{ 
			
				
		//	int xx1	=src_x + (int)((xx+minx)*cos_a+(yy+miny)*sin_a);
		//	int yy1	=src_y + (int)((yy+miny)*cos_a-(xx+minx)*sin_a); 
			
			
			/*f3	=f1*f2;
			f1	+=23.2;
			f2	+=24.56;*/
			
			xx1	=inc_x + ((xx*cos_a)>>16);	if(xx1<src_x || xx1>src_dx)	continue;
			yy1	=inc_y - ((xx*sin_a)>>16);	if(yy1<src_y || yy1>src_dy)	continue;
			
			__set_pixel(	dstSurface,xx0,yy0,
								__get_pixel(srcSurface,xx1,yy1));
			
				
		} 

			
	} 
	
	return	1;
}

/*============================================================================*/

static	int	gdev_alpha_blend(
struct SURFACE *dstSurface,int dst_x,int dst_y,int dst_dx,int dst_dy,
struct SURFACE *srcSurface,int src_x,int src_y,int src_dx,int src_dy,
BLENDFUNCTION *bf)
{

	int		xx,xx0,x_scal,y_scal;
	COLORREF color;
	LCD_COLOR *dst_p;
	////
	
	//x,yϵ(㷨Ż:->˷->ӷ)
	x_scal	=65536.0/((float)dst_dx/(float)src_dx);	
	y_scal	=65536.0/((float)dst_dy/(float)src_dy);
	
	
	dst_dx	+=dst_x;	//dst_xĽ
	dst_dy	+=dst_y;	//dst_yĽ
	
	src_x	<<=16;
	src_y	<<=16;
	
	
		
	if(bf->AlphaFormat&(AC_DST_NO_ALPHA|AC_SRC_NO_ALPHA))
	{
		for(;dst_y<dst_dy;dst_y++)
		{
			xx		=src_x;
			dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
			for(xx0=dst_x;xx0<dst_dx;xx0++)
			{
				color	=AlphaBlendColor(	__get_pixel(srcSurface,xx>>16,src_y>>16),
											__get_pixel(dstSurface,xx0,dst_y),
											bf->SourceConstantAlpha);
						
				__set_data(dst_p,color);
				
				xx+=x_scal;
			}
					
			src_y	+=y_scal;
		}
			
		return	1;
	}
	else
	{
				
		for(;dst_y<dst_dy;dst_y++)
		{
			xx		=src_x;
			dst_p	=__set_addr(dstSurface,dst_x,dst_y);
					
			for(xx0=dst_x;xx0<dst_dx;xx0++)
			{
				color	=__get_pixel(srcSurface,xx>>16,src_y>>16);
				color	=gdev_alpha_blend_color(	color,
													__get_pixel(dstSurface,xx0,dst_y),
													color>>24);
						
				__set_data(dst_p,color);
						
				xx+=x_scal;
			}
					
			src_y	+=y_scal;
		}
			
		return	1;
				
		////////
		
	}
	
	return 0;


}


/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/

//static	GDEV	gdev;

GDEV* arch_GDevInit(void)
{
	int	i,size;
	U8	*p;
	////
	
	screen_surface.buf		=LCD_BUF_VA_BASE;
	screen_surface.bpp		=LCD_BPP;
	screen_surface.xref		=LCD_XSIZE;
	screen_surface.yref		=LCD_YSIZE;
	screen_surface.xmax		=LCD_XSIZE-1;
	screen_surface.ymax		=LCD_YSIZE-1;
	screen_surface.xoffset	=0;
	screen_surface.yoffset	=0;
	screen_surface.offset	=0;
	screen_surface.cur		=LCD_BUF_VA_BASE;
	
	
	lcd_init();
	////
	memset(&gdev,0,sizeof(GDEV));
	////
	
	gdev.Init			=lcd_init;
	gdev.Resume			=lcd_resume;
	gdev.Suspend		=lcd_suspend;
	
	gdev.GetSurface		=get_screen_surface;
	gdev.ColorRef		=color_ref;
	gdev.GetRGB			=get_rgb;
	gdev.AlphaBlendColor	=gdev_alpha_blend_color;
	
	
	gdev.SetPixel		=set_pixel;
	gdev.GetPixel		=get_pixel;
	gdev.HLine			=hline;
	gdev.VLine			=vline;
	gdev.Line			=line;
	gdev.FillRectangle	=fill_rectangle;
	gdev.PutImage		=put_image;
	gdev.GetImage		=get_image;
	gdev.DrawDIBSection_1BPP		=draw_dib_1bpp;
	gdev.DrawDIBSection_4BPP		=draw_dib_4bpp;
	gdev.DrawDIBSection_8BPP		=draw_dib_8bpp;
	gdev.DrawDIBSection_RGB555	=draw_dib_RGB555;
	gdev.DrawDIBSection_RGB888	=draw_dib_RGB888;
	gdev.DrawDIBSection_BGR888	=draw_dib_BGR888;
	gdev.DrawDIBSection_ARGB8888	=draw_dib_ARGB8888;
	gdev.DitheredFill			=dithered_fill;
		
	gdev.BitBlt				=gdev_bit_blt;
	gdev.StretchBlt			=gdev_stretch_blt;
	gdev.TransparentBlt		=gdev_transparent_blt;
	gdev.AlphaBlend			=gdev_alpha_blend;
	gdev.RotateBlt			=gdev_rotate_blt;
	
	//fill_rectangle(&screen_surface,20,40,128,64,color_ref(200,0,0));
	//Sleep(1000);
	return &gdev;
	
	

}




/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
/*============================================================================*/
